<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "account_device".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "AccountDevice".
 *
 * Columns in table "account_device" available as properties of the model,
 * followed by relations of table "account_device" available as properties of the model.
 *
 * @property integer $id
 * @property integer $localization_id
 * @property integer $device_id
 * @property integer $account_id
 * @property integer $practice_id
 * @property string $status
 * @property integer $send_email_review_to_account
 * @property integer $is_replacement
 * @property string $date_shipped
 * @property string $shipment_tracking_number
 * @property string $logo_path
 * @property string $logo_hero_path
 * @property string $date_enrolled
 * @property string $date_last_accessed
 * @property string $date_last_review_received
 * @property string $date_delivered
 * @property string $program_title
 * @property string $initial_cta
 * @property string $referred_as_plural
 * @property string $referred_as
 * @property string $status_reason
 * @property string $logo_office_staff_path
 * @property string $notes
 * @property string $denied_languages
 * @property integer $show_provider_specialties
 * @property integer $send_followup_email
 * @property integer $send_followup_sms
 * @property integer $email_required
 *
 * @property Localization $localization
 * @property Account $account
 * @property Device $device
 * @property Practice $practice
 * @property AccountDeviceHistory[] $accountDeviceHistories
 * @property AccountDeviceProvider[] $accountDeviceProviders
 * @property Patientemail[] $patientemails
 * @property ReviewRequestExternal[] $reviewRequestExternals
 */
abstract class BaseAccountDevice extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'account_device';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'AccountDevice|AccountDevices', $n);
    }

    public static function representingColumn()
    {
        return 'status';
    }

    public function rules()
    {
        return array(
            array(
                'device_id, account_id, date_shipped, shipment_tracking_number, logo_path, logo_hero_path,
                date_enrolled, program_title, initial_cta', 'required'
            ),
            array(
                'localization_id, device_id, account_id, practice_id, send_email_review_to_account, is_replacement,
                show_provider_specialties, send_followup_email, send_followup_sms, email_required',
                'numerical',
                'integerOnly' => true
            ),
            array('status', 'length', 'max' => 1),
            array('shipment_tracking_number', 'length', 'max' => 45),
            array(
                'logo_path, logo_hero_path, program_title, initial_cta, status_reason, logo_office_staff_path,
                denied_languages',
                'length',
                'max' => 255
            ),
            array('referred_as_plural, referred_as', 'length', 'max' => 50),
            array('date_last_accessed, date_last_review_received, date_delivered, notes', 'safe'),
            array(
                'localization_id, practice_id, status, send_email_review_to_account, is_replacement, date_last_accessed,
                date_last_review_received, date_delivered, referred_as_plural, referred_as, status_reason,
                logo_office_staff_path, notes, denied_languages, show_provider_specialties, send_followup_email,
                send_followup_sms, email_required',
                'default',
                'setOnEmpty' => true,
                'value' => null
            ),
            array(
                'id, localization_id, device_id, account_id, practice_id, status, send_email_review_to_account,
                is_replacement, date_shipped, shipment_tracking_number, logo_path, logo_hero_path, date_enrolled,
                date_last_accessed, date_last_review_received, date_delivered, program_title, initial_cta,
                referred_as_plural, referred_as, status_reason, logo_office_staff_path, notes, denied_languages,
                show_provider_specialties, send_followup_email, send_followup_sms, email_required, device_nickname,
                account_name, practice_name',
                'safe',
                'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'localization' => array(self::BELONGS_TO, 'Localization', 'localization_id'),
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
            'device' => array(self::BELONGS_TO, 'Device', 'device_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'accountDeviceHistories' => array(self::HAS_MANY, 'AccountDeviceHistory', 'account_device_id'),
            'accountDeviceProviders' => array(self::HAS_MANY, 'AccountDeviceProvider', 'account_device_id'),
            'patientemails' => array(self::HAS_MANY, 'Patientemail', 'account_device_id'),
            'reviewRequestExternals' => array(self::HAS_MANY, 'ReviewRequestExternal', 'account_device_id'),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'localization_id' => null,
            'device_id' => null,
            'account_id' => null,
            'practice_id' => null,
            'status' => Yii::t('app', 'Status'),
            'send_email_review_to_account' => Yii::t('app', 'Send Email Review To Account'),
            'is_replacement' => Yii::t('app', 'Is Replacement'),
            'date_shipped' => Yii::t('app', 'Date Shipped'),
            'shipment_tracking_number' => Yii::t('app', 'Shipment Tracking Number'),
            'logo_path' => Yii::t('app', 'Logo Path'),
            'logo_hero_path' => Yii::t('app', 'Logo Hero Path'),
            'date_enrolled' => Yii::t('app', 'Date Enrolled'),
            'date_last_accessed' => Yii::t('app', 'Date Last Accessed'),
            'date_last_review_received' => Yii::t('app', 'Date Last Review Received'),
            'date_delivered' => Yii::t('app', 'Date Delivered'),
            'program_title' => Yii::t('app', 'Program Title'),
            'initial_cta' => Yii::t('app', 'Initial Cta'),
            'referred_as_plural' => Yii::t('app', 'Referred As Plural'),
            'referred_as' => Yii::t('app', 'Referred As'),
            'status_reason' => Yii::t('app', 'Status Reason'),
            'logo_office_staff_path' => Yii::t('app', 'Logo Office Staff Path'),
            'notes' => Yii::t('app', 'Notes'),
            'denied_languages' => Yii::t('app', 'Denied Languages'),
            'show_provider_specialties' => Yii::t('app', 'Show Provider Specialties'),
            'send_followup_email' => Yii::t('app', 'Send Followup Email'),
            'send_followup_sms' => Yii::t('app', 'Send Followup Sms'),
            'email_required' => Yii::t('app', 'Email Required'),
            'localization' => null,
            'account' => null,
            'device' => null,
            'practice' => null,
            'accountDeviceHistories' => null,
            'accountDeviceProviders' => null,
            'patientemails' => null,
            'reviewRequestExternals' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('localization_id', $this->localization_id);
        $criteria->compare('device_id', $this->device_id);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('status', $this->status, true);
        $criteria->compare('send_email_review_to_account', $this->send_email_review_to_account);
        $criteria->compare('is_replacement', $this->is_replacement);
        $criteria->compare('date_shipped', $this->date_shipped, true);
        $criteria->compare('shipment_tracking_number', $this->shipment_tracking_number, true);
        $criteria->compare('logo_path', $this->logo_path, true);
        $criteria->compare('logo_hero_path', $this->logo_hero_path, true);
        $criteria->compare('date_enrolled', $this->date_enrolled, true);
        $criteria->compare('date_last_accessed', $this->date_last_accessed, true);
        $criteria->compare('date_last_review_received', $this->date_last_review_received, true);
        $criteria->compare('date_delivered', $this->date_delivered, true);
        $criteria->compare('program_title', $this->program_title, true);
        $criteria->compare('initial_cta', $this->initial_cta, true);
        $criteria->compare('referred_as_plural', $this->referred_as_plural, true);
        $criteria->compare('referred_as', $this->referred_as, true);
        $criteria->compare('status_reason', $this->status_reason, true);
        $criteria->compare('logo_office_staff_path', $this->logo_office_staff_path, true);
        $criteria->compare('notes', $this->notes, true);
        $criteria->compare('denied_languages', $this->denied_languages, true);
        $criteria->compare('show_provider_specialties', $this->show_provider_specialties);
        $criteria->compare('send_followup_email', $this->send_followup_email);
        $criteria->compare('send_followup_sms', $this->send_followup_sms);
        $criteria->compare('email_required', $this->email_required);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }
}
